routes/web.php
<?php

use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\ServiceController;
use App\Http\Controllers\Admin\DestinationController;
use App\Http\Controllers\Admin\UserAdminController;
use App\Http\Controllers\Admin\BookingController;
use App\Http\Controllers\Admin\PaymentStatusController;
use App\Http\Controllers\Page\HomeController;
use App\Http\Controllers\Page\ServiceController as PageServiceController;
use App\Http\Controllers\Page\DestinationController as PageDestinationController;
use App\Http\Controllers\Page\BookingController as PageBookingController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();
Route::get('template', function () {
  return view('layouts.admin.app');
});


Route::prefix('admin-dashboard')->group(function () {
  Route::get('/', [AdminController::class, 'dashboard'])->name('admin.dashboard');
  Route::resource('service', ServiceController::class)->middleware(['role:1,2']);
  Route::resource('destination', DestinationController::class)->middleware(['role:1,2']);
  Route::resource('booking', BookingController::class)->middleware(['role:1,2']);
  Route::resource('payment', PaymentStatusController::class)->middleware(['role:1,2']);
});

Route::middleware(['role:3'])->group(function () {
});

// Client
Route::get('/', [HomeController::class, 'landing'])->name('landing'); // Landing

Route::get('/destination/{id}', [PageDestinationController::class, 'detail'])->name('destinations'); // Detail Destination

Route::get('/service/{id}', [PageServiceController::class, 'showService'])->name('showService'); // Show Service

Route::post('/booking', [PageBookingController::class, 'store'])->name('newBooking'); // Booking

Route::get('/booking', [PageBookingController::class, 'index'])->name('bookingAll'); // Booking

Route::get('/booking/{id}', [PageBookingController::class, 'show'])->name('bookingShow'); // Booking

Route::get('/testimonial/{id}', [PageBookingController::class, 'Createtestimonial'])->name('createTestimonial'); // Booking

Route::post('/', [PageBookingController::class, 'Newtestimonial'])->name('newTestimonial'); // Booking

app/Models/Destination.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Destination extends Model
{
    use HasFactory;

    protected $table = 'destinations';

    protected $fillable = [
      'name',
      'region',
      'description',
      'image',
      'price',
      'service_id',
    ];

    public function service()
    {
      return $this->belongsTo(Service::class);
    }

    public function booking()
    {
      return $this->hasMany(Booking::class);
    }

    public function testimonial()
    {
      return $this->hasMany(Testimonial::class);
    }
}

app/Http/Controllers/Admin/DestinationController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Destination;
use App\Models\Service;
use Illuminate\Http\Request;
use File;

class DestinationController extends Controller
{
    // Auth Middleware
    public function __construct()
    {
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // $destinations = Destination::join('services', 'destinations.id');
        $services = Service::all();
        $destinations = Destination::all();
        return view('admin.destination.index', compact('destinations', 'services'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $services = Service::all();
        $destinations = Destination::all();
        return view('admin.destination.create', compact('destinations', 'services'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name'        => 'required',
            'region'      => 'required',
            'description' => 'required',
            'image'       => 'required',
            'price'       => 'required',
            'service_id'  => 'required',
        ]);

        $newNameImage = time().'.'.$request->image->extension();
        $request->image->move(public_path('image'), $newNameImage);

        $destinations = new Destination;

        $destinations->name         = $request->name;
        $destinations->service_id   = $request->service_id;
        $destinations->region       = $request->region;
        $destinations->description  = $request->description;
        $destinations->image        = $newNameImage;
        $destinations->price        = $request->price;
        $destinations->save();

        toast('Data Berhasil Disimpan!', 'success');
        return redirect()->route('destination.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $destinations = Destination::where('id', $id)->first();
        $services = Service::all();
        // $defaultService = Service::where('id', $destinations->service_id)->first();

        return view('admin.destination.edit', compact('destinations', 'services'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'name'        => 'required',
            'region'      => 'required',
            'description' => 'required',
            // 'image'       => 'required',
            'price'       => 'required',
            'service_id'  => 'required',
        ]);

        $destinations = Destination::find($id);

        $destinations->name         = $request->name;
        $destinations->service_id   = $request->service_id;
        $destinations->region       = $request->region;
        $destinations->description  = $request->description;
        $destinations->price        = $request->price;
        if ($request->has('image'))
        {
            $path = 'image/';
            File::delete($path. $destinations->image);

            $newNameImage = time().'.'.$request->image->extension();
            $request->image->move(public_path('image'), $newNameImage);

            $destinations->image        = $newNameImage;
        }

        $destinations->save();

        toast('Data Berhasil Diperbarui!', 'success');
        return redirect()->route('destination.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $destinations = Destination::where('id', $id)->delete();

        toast('Data Berhasil Dihapus!', 'success');
        return redirect()->route('destination.index');
    }
}

app/Http/Controllers/Page/DestinationController.php
<?php

namespace App\Http\Controllers\Page;

use App\Http\Controllers\Controller;
use App\Models\Destination;
use App\Models\Booking;
use Illuminate\Support\Facades\Auth;
use App\Models\Service;
use App\Models\Testimonial;
use Illuminate\Http\Request;

class DestinationController extends Controller
{
    public function detail($id)
    {
        $destinations = Destination::where('id', $id)->first();
        $testimonials = Testimonial::where('destination_id', $id)->get();
        $rating = Testimonial::where('destination_id', $id)->avg('rating');

        return view('page.destination.detail', compact('destinations', 'testimonials', 'rating'));
    }
}

resources/views/admin/destination/create.blade.php
@extends('layouts.admin.app')
@section('title')
  Add Destination | Dashboard
@endsection

@section('content')
<div class="col-md-7 mx-auto">
  <div class="card mb-4">
      <div class="card-header d-flex justify-content-between align-items-center">
          <div class="">
            <h5 class="card-title m-0">Add Destination</h5>
          </div>
          <div class="">
            <a href="{{ route('destination.index') }}" class="badge badge-pill bg-label-secondary p-2">
                <i class="bx bx-x"></i>
            </a>
          </div>
      </div>

      <div class="card-body">

        <form action="{{ route('destination.store') }}" method="POST"
          enctype="multipart/form-data">
          @csrf

            <div class="row">
              <div class="col-md-12">

                <div class="mb-3">
                  <label class="form-label" for="name">
                    Nama Destination
                    <span class="text-danger">*</span>
                  </label>
                  <input type="text" class="form-control @error('name') is-invalid @enderror"
                  placeholder="Nama Destinations" value="{{ old('name') }}" name="name" id="name" required="">

                  @error('name')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

                <div class="mb-3">
                  <label class="form-label" for="service_id">
                    Service
                    <span class="text-danger">*</span>
                  </label>
                  <select name="service_id" class="form-control" required>
                    @foreach($services as $item)
                      <option value="{{ $item->id }}">{{ $item->name }}</option>
                    @endforeach
                  </select>
                </div>

                <div class="mb-3">
                  <label class="form-label" for="region">
                    Region
                    <span class="text-danger">*</span>
                  </label>
                  <input type="text" class="form-control @error('region') is-invalid @enderror"
                  placeholder="Nama Region" value="{{ old('region') }}" name="region" id="region" required="">

                  @error('region')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

                <div class="mb-3">
                    <label class="form-label" for="description">Descriptions
                        <span class="text-danger">*</span>
                    </label>
                    <textarea type="text" class="form-control " placeholder="Descriptions"
                    value="{{ old('description') }}" name="description" id="description" required></textarea>
                </div>

                <div class="mb-3">
                  <label class="form-label" for="image">
                    Image
                    <span class="text-danger">*</span>
                  </label>
                  <input type="file" class="form-control @error('image') is-invalid @enderror"
                  placeholder="Select Images" value="{{ old('image') }}" name="image" id="image" required="">

                  @error('image')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

                <div class="mb-3">
                  <label class="form-label" for="price">
                    Price
                    <span class="text-danger">*</span>
                  </label>
                  <input type="number" class="form-control @error('price') is-invalid @enderror"
                  placeholder="Price Destination" value="{{ old('price') }}" name="price" id="price" required="">

                  @error('price')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

            <button type="submit" class="btn btn-primary mt-3 px-5">Submit</button>
          </form>
      </div>
  </div>
</div>
</div>
@endsection

resources/views/admin/destination/edit.blade.php
@extends('layouts.admin.app')
@section('title')
  Edit Destination | Dashboard
@endsection

@section('content')
<div class="col-md-7 mx-auto">
  <div class="card mb-4">
      <div class="card-header d-flex justify-content-between align-items-center">
          <div class="">
            <h5 class="card-title m-0">Edit Destination</h5>
          </div>
          <div class="">
            <a href="{{ route('destination.index') }}" class="badge badge-pill bg-label-secondary p-2">
                <i class="bx bx-x"></i>
            </a>
          </div>
      </div>

      <div class="card-body">

        <form action="{{ route('destination.update', $destinations->id) }}" method="POST"
          enctype="multipart/form-data">
          @csrf
          @method('put')

            <div class="row">
              <div class="col-md-12">

                <div class="mb-3">
                  <label class="form-label" for="name">
                    Nama Destination
                    <span class="text-danger">*</span>
                  </label>
                  <input type="text" class="form-control @error('name') is-invalid @enderror"
                  placeholder="Nama Destinations" value="{{ $destinations->name }}" name="name" id="name" required="">

                  @error('name')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

                <div class="mb-3">
                  <label class="form-label" for="service_id">
                    Service
                    <span class="text-danger">*</span>
                  </label>
                  <select name="service_id" class="form-control" required selected="">
                    {{-- <option value="{{ $destinations->service_id }}">{{ $item->service->name }}</option> --}}
                    @foreach($services as $item)
                      @if ($item->id === $destinations->service_id)
                          <option value="{{ $item->id }}" selected>{{ $item->name }}</option>
                      @else
                          <option value="{{ $item->id }}">{{ $item->name }}</option>
                      @endif
                    @endforeach
                  </select>
                </div>

                <div class="mb-3">
                  <label class="form-label" for="region">
                    Region
                    <span class="text-danger">*</span>
                  </label>
                  <input type="text" class="form-control @error('region') is-invalid @enderror"
                  placeholder="Nama Region" value="{{ $destinations->region }}" name="region" id="region" required="">

                  @error('region')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

                <div class="mb-3">
                    <label class="form-label" for="description">Descriptions
                        <span class="text-danger">*</span>
                    </label>
                    <textarea type="text" class="form-control " placeholder="Descriptions"
                    value="{{ old('description') }}" name="description" id="description" required>{{ $destinations->description }}</textarea>
                </div>

                <div class="mb-3">
                  <label class="form-label" for="image">
                    Image
                    <span class="text-danger">*</span>
                  </label>
                  <input type="file" class="form-control"
                  placeholder="Select Images" value="{{ $destinations->image }}" name="image" id="image">
                </div>

                <div class="mb-3">
                  <label class="form-label" for="price">
                    Price
                    <span class="text-danger">*</span>
                  </label>
                  <input type="number" class="form-control @error('price') is-invalid @enderror"
                  placeholder="Price Destination" value="{{ $destinations->price }}" name="price" id="price" required="">

                  @error('price')
                    <div class="alert alert-danger mt-2">
                      {{ $message }}
                    </div>
                  @enderror
                </div>

            <button type="submit" class="btn btn-primary mt-3 px-5">Update</button>
          </form>
      </div>
  </div>
</div>
</div>
@endsection

resources/views/admin/destination/index.blade.php
@extends('layouts.admin.app')
@section('title')
  List Destinations
@endsection

@push('scripts')
<script>
  $(function () {
    $("#destinationTable").DataTable();
  });
</script>
<script type="text/javascript" src="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.js"></script>
@endpush

@push('style')
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/dt/dt-1.13.1/datatables.min.css"/>
@endpush

@section('content')
  <div class="row">
    <div class="col-md-12">

      <div class="card mb-4">

        <div class="card-header border-bottom d-flex justify-content-between">
          <h5 class="card-title mb-0">@yield('title')</h5>
        </div>

        <div class="row mx-1 my-3">
          <div class="col-12 col-md-6 d-flex align-items-center justify-content-between justify-content-md-start gap-2 mb-3 mb-md-0">
            <div class="text-xl-end text-lg-start text-md-end text-start mt-md-0">
              <a href="{{ route('destination.create') }}" class="btn btn-primary" type="button">
                  <span>
                      <i class="bx bx-plus me-md-2"></i>
                      <span class="d-md-inline-block d-none">Add New Destination</span>
                  </span>
              </a>
            </div>
          </div>
        </div>
        <div class="card-body">
          <div class="table-responsive text-nowrap">
            <table id="destinationTable" class="stripe">
              <thead class="table-primary">
                  <tr>
                      <th>#</th>
                      <th>Name Destination</th>
                      <th>Service</th>
                      <th>Region</th>
                      <th>Description</th>
                      <th>Image</th>
                      <th>Price</th>
                      <th>Actions</th>
                  </tr>
              </thead>
              <tbody class="table-border-bottom-0">

                @forelse($destinations as $key => $item)
                @php
                  $name = $item->name;
                @endphp
                <tr>
                    <td>{{ $key + 1}}</td>
                    <td>{{ $item->name }}</td>
                    <td>{{ $item->service->name }}</td>
                    <td>{{ $item->region }}</td>
                    <td class="text-truncate" style="max-width: 200px;">{{ $item->description }}</td>
                    <td>
                      <div class="d-flex align-content-center align-items-center my-3 overflow-hidden rounded"
                          style="height: 50px; width: 50px;">
                          <img class="mr-3 img-fluid" src="{{asset('/image/'.$item->image)}}" width="50px">
                      </div>
                    </td>
                    <td>{{ $item->price }}</td>
                    <td class="col-2">
                      <a class="btn btn-link btn-sm text-light" href="{{ route('destination.edit', $item->id) }}">
                        <i class="bx bx-edit-alt"></i>
                        Edit
                      </a>
                      <a class="btn btn-link btn-sm text-light" onclick="" data-bs-toggle="modal"
                      data-bs-target="#modal-delete-3_{{ $item->id }}" data-action="{{ route('destination.destroy', $item->id) }}">
                      <i class="bx bx-trash "></i>
                          Delete
                      </a>
                      <!-- modal delete-->
                      <div class="modal fade" id="modal-delete-3_{{ $item->id }}" tabindex="-1" aria-hidden="true" style="display: none;">
                        <div class="modal-dialog modal-dialog-centered" role="document"><div class="modal-content">
                          <div class="modal-header">
                              <h5 class="modal-title" id="modal-deleteTitle">Hapus Data</h5>
                              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                          </div>

                          <form action="{{ route('destination.destroy', $item->id) }}" method="post">
                            @csrf
                            @method('delete')
                            <div class="modal-body">
                                <h5 class="text-center">Yakin, akan menghapus <b>{{ $item->name }}</b> ?</h5>
                            </div>
                            <div class="modal-footer justify-content-between">
                                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                                <button type="submit" class="btn btn-danger">Ya! Hapus</button>
                            </div>
                          </form>
                        </div>
                      </div>
                    </div>
                  </td>
                </tr>
                @empty

                @endforelse
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
@endsection